org.apache.lucene.analysis.fr

## Class FrenchAnalyzer

- java.lang.Object
- - org.apache.lucene.analysis.Analyzer
  - - org.apache.lucene.analysis.StopwordAnalyzerBase
    - - org.apache.lucene.analysis.fr.FrenchAnalyzer

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public final class FrenchAnalyzer
      extends StopwordAnalyzerBase

  `Analyzer` for French language.

  Supports an external list of stopwords (words that will not be indexed at all) and an external list of exclusions (word that will not be stemmed, but indexed). A default set of stopwords is used unless an alternative list is specified, but the exclusion list is empty by default.

  NOTE: This class uses the same `Version` dependent settings as `StandardAnalyzer`.

  Since:
    3.1

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.analysis.Analyzer

      `Analyzer.ReuseStrategy, Analyzer.TokenStreamComponents`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static CharArraySet` | `DEFAULT_ARTICLES` Default set of articles for ElisionFilter
    `static String` | `DEFAULT_STOPWORD_FILE` File containing default French stopwords.

    - ### Fields inherited from class org.apache.lucene.analysis.StopwordAnalyzerBase

      `stopwords`

    - ### Fields inherited from class org.apache.lucene.analysis.Analyzer

      `GLOBAL_REUSE_STRATEGY, PER_FIELD_REUSE_STRATEGY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FrenchAnalyzer()` Builds an analyzer with the default stop words (`getDefaultStopSet()`).
    `FrenchAnalyzer(CharArraySet stopwords)` Builds an analyzer with the given stop words
    `FrenchAnalyzer(CharArraySet stopwords, CharArraySet stemExclutionSet)` Builds an analyzer with the given stop words

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Analyzer.TokenStreamComponents` | `createComponents(String fieldName)` Creates `Analyzer.TokenStreamComponents` used to tokenize all the text in the provided `Reader`.
    `static CharArraySet` | `getDefaultStopSet()` Returns an unmodifiable instance of the default stop-words set.
    `protected TokenStream` | `normalize(String fieldName, TokenStream in)`

    - ### Methods inherited from class org.apache.lucene.analysis.StopwordAnalyzerBase

      `getStopwordSet, loadStopwordSet, loadStopwordSet, loadStopwordSet`

    - ### Methods inherited from class org.apache.lucene.analysis.Analyzer

      `attributeFactory, close, getOffsetGap, getPositionIncrementGap, getReuseStrategy, getVersion, initReader, initReaderForNormalization, normalize, setVersion, tokenStream, tokenStream`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_STOPWORD_FILE

          public static final String DEFAULT_STOPWORD_FILE

      File containing default French stopwords.
      See Also:
        Constant Field Values

    - #### DEFAULT_ARTICLES

          public static final CharArraySet DEFAULT_ARTICLES

      Default set of articles for ElisionFilter

  - ### Constructor Detail

    - #### FrenchAnalyzer

          public FrenchAnalyzer()

      Builds an analyzer with the default stop words (`getDefaultStopSet()`).

    - #### FrenchAnalyzer

          public FrenchAnalyzer(CharArraySet stopwords)

      Builds an analyzer with the given stop words
      Parameters:
        `stopwords` - a stopword set

    - #### FrenchAnalyzer

          public FrenchAnalyzer(CharArraySet stopwords,
                                CharArraySet stemExclutionSet)

      Builds an analyzer with the given stop words
      Parameters:
        `stopwords` - a stopword set
        `stemExclutionSet` - a stemming exclusion set

  - ### Method Detail

    - #### getDefaultStopSet

          public static CharArraySet getDefaultStopSet()

      Returns an unmodifiable instance of the default stop-words set.
      Returns:
        an unmodifiable instance of the default stop-words set.

    - #### createComponents

          protected Analyzer.TokenStreamComponents createComponents(String fieldName)

      Creates `Analyzer.TokenStreamComponents` used to tokenize all the text in the provided `Reader`.
      Specified by:
        `createComponents` in class `Analyzer`
      Returns:
        `Analyzer.TokenStreamComponents` built from a `StandardTokenizer` filtered with `ElisionFilter`, `LowerCaseFilter`, `StopFilter`, `SetKeywordMarkerFilter` if a stem exclusion set is provided, and `FrenchLightStemFilter`

    - #### normalize

          protected TokenStream normalize(String fieldName,
                                          TokenStream in)

      Overrides:
        `normalize` in class `Analyzer`

Copyright © 2000-2021 Apache Software Foundation. All Rights Reserved.